searchNodes=[{"doc":"Clickhouse driver for Elixir.This module handles the connection to Clickhouse, providing support for queries, connection backoff, logging, pooling and more.","ref":"Clickhousex.html","title":"Clickhousex","type":"module"},{"doc":"","ref":"Clickhousex.html#child_spec/1","title":"Clickhousex.child_spec/1","type":"function"},{"doc":"","ref":"Clickhousex.html#defaults/1","title":"Clickhousex.defaults/1","type":"function"},{"doc":"","ref":"Clickhousex.html#query/4","title":"Clickhousex.query/4","type":"function"},{"doc":"","ref":"Clickhousex.html#query!/4","title":"Clickhousex.query!/4","type":"function"},{"doc":"Connect to ClickHouse. opts expects a keyword list with zero or more of:* `:scheme` - Scheme (:http | :https). * default value: :http * `:hostname` - The server hostname. * default value: localhost * `:database` - Database name. * default value: &quot;default&quot; * `:port` - The server port number. * default value: 8123 * `:username` - Username. * default value: empty * `:password` - User&#39;s password. * default value: empty","ref":"Clickhousex.html#start_link/1","title":"Clickhousex.start_link/1","type":"function"},{"doc":"","ref":"Clickhousex.html#timeout/0","title":"Clickhousex.timeout/0","type":"function"},{"doc":"A connection process name, pid or reference.A connection reference is used when making multiple requests to the same connection, see transaction/3.","ref":"Clickhousex.html#t:conn/0","title":"Clickhousex.conn/0","type":"type"},{"doc":"Behaviour for input and/or output format.If none of the out of the box codecs suits your needs, you can implement one of the supported ones yourself.","ref":"Clickhousex.Codec.html","title":"Clickhousex.Codec","type":"behaviour"},{"doc":"","ref":"Clickhousex.Codec.html#c:append/2","title":"Clickhousex.Codec.append/2","type":"callback"},{"doc":"","ref":"Clickhousex.Codec.html#c:decode/1","title":"Clickhousex.Codec.decode/1","type":"callback"},{"doc":"","ref":"Clickhousex.Codec.html#c:encode/3","title":"Clickhousex.Codec.encode/3","type":"callback"},{"doc":"","ref":"Clickhousex.Codec.html#c:new/0","title":"Clickhousex.Codec.new/0","type":"callback"},{"doc":"","ref":"Clickhousex.Codec.html#c:request_format/0","title":"Clickhousex.Codec.request_format/0","type":"callback"},{"doc":"","ref":"Clickhousex.Codec.html#c:response_format/0","title":"Clickhousex.Codec.response_format/0","type":"callback"},{"doc":"","ref":"Clickhousex.Codec.html#t:select_response/0","title":"Clickhousex.Codec.select_response/0","type":"type"},{"doc":"","ref":"Clickhousex.Codec.html#t:state/0","title":"Clickhousex.Codec.state/0","type":"type"},{"doc":"Allows modules that use this module to create efficient extractor functions that speak clickhouse's binary protocol.To define extractors, annotate a function with the extract attribute like this:@extract length: :varint def extract_length(&lt;&lt;data::binary&gt;&gt;, length, other_param) do do_something_with_length(data, length, other_param) end def do_something_with_length(_data, length, other_param) do {other_param, length} endIn the above example, a function named extract_length/2 will be created, which, when passed a binary, will extract the length varint from it, and call the function above, passing the unparsed part of the binary and the extracted length varint to it.Usage looks like this{:ok, binary_from_network} = :gen_tcp.recv(conn, 0) {:this_is_passed_along, length} = extract_length(binary_from_network, :this_is_passed_along)If there isn't enough data to parse, a resume tuple is returned. The second element of the tuple is a function that when called with more data, picks up the parse operation where it left off.{:resume, resume_fn} = extract_length(&lt;&lt;&gt;&gt;, :this_is_passed_along) {:ok, data} = :gen_tcp.recv(conn, 0) {:this_is_passed_along, length} = resume_fn.(data)PerformanceAll functions generated by this module take advantage of binary optimizations, resuse match contexts and won't create sub-binaries.CompletenessThe following extractors are implemented:Variable length integers :varintSigned integers: :i8, :i16, :i32, i64Unsigned integers: :u8, :u16, :u32, :u64Floats: :f32, :f64Strings: :stringBooleans: :booleanDates: :date, :datetimeLists of the above scalar types {:list, scalar}Nullable instances of all the above {:nullable, scalar} or {:list, {:nullable, scalar}}","ref":"Clickhousex.Codec.Binary.Extractor.html","title":"Clickhousex.Codec.Binary.Extractor","type":"module"},{"doc":"Clickhousex.Codec implementation for JSON output format.See JSON, JSONCompact.","ref":"Clickhousex.Codec.JSON.html","title":"Clickhousex.Codec.JSON","type":"module"},{"doc":"Callback implementation for Clickhousex.Codec.encode/3.","ref":"Clickhousex.Codec.JSON.html#encode/3","title":"Clickhousex.Codec.JSON.encode/3","type":"function"},{"doc":"A codec that speaks Clickhouse's RowBinary formatTo use this codec, set the application :clickhousex :codec application variable: config :clickhousex, codec: Clickhousex.Codec.RowBinary","ref":"Clickhousex.Codec.RowBinary.html","title":"Clickhousex.Codec.RowBinary","type":"module"},{"doc":"","ref":"Clickhousex.Codec.RowBinary.html#state/1","title":"Clickhousex.Codec.RowBinary.state/1","type":"macro"},{"doc":"","ref":"Clickhousex.Codec.RowBinary.html#state/2","title":"Clickhousex.Codec.RowBinary.state/2","type":"macro"},{"doc":"Utility functions for Clickhousex.Codec.RowBinary, can not be defined in the same module because they are required at compile time.","ref":"Clickhousex.Codec.RowBinary.Utils.html","title":"Clickhousex.Codec.RowBinary.Utils","type":"module"},{"doc":"","ref":"Clickhousex.Codec.RowBinary.Utils.html#extractor_name/1","title":"Clickhousex.Codec.RowBinary.Utils.extractor_name/1","type":"function"},{"doc":"","ref":"Clickhousex.Codec.RowBinary.Utils.html#type_permutations/1","title":"Clickhousex.Codec.RowBinary.Utils.type_permutations/1","type":"function"},{"doc":"Routines for Values input/output format.NB: This module does not implement Clickhousex.Codec behaviour.","ref":"Clickhousex.Codec.Values.html","title":"Clickhousex.Codec.Values","type":"module"},{"doc":"","ref":"Clickhousex.Codec.Values.html#encode/3","title":"Clickhousex.Codec.Values.encode/3","type":"function"},{"doc":"Query struct returned from a successfully prepared query.","ref":"Clickhousex.Query.html","title":"Clickhousex.Query","type":"module"},{"doc":"","ref":"Clickhousex.Query.html#new/1","title":"Clickhousex.Query.new/1","type":"function"},{"doc":"","ref":"Clickhousex.Query.html#t:t/0","title":"Clickhousex.Query.t/0","type":"type"},{"doc":"Result struct returned from any successful query. Its fields are:command - An atom of the query commandcolumns - The column names;rows - The result set. A list of lists, each inner list corresponding to a row, each element in the inner list corresponds to a column;num_rows - The number of fetched or affected rows;","ref":"Clickhousex.Result.html","title":"Clickhousex.Result","type":"module"},{"doc":"","ref":"Clickhousex.Result.html#t:t/0","title":"Clickhousex.Result.t/0","type":"type"},{"doc":"Defines an error returned from the client.","ref":"Clickhousex.Error.html","title":"Clickhousex.Error","type":"exception"},{"doc":"","ref":"Clickhousex.Error.html#t:t/0","title":"Clickhousex.Error.t/0","type":"type"}]